<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>cachedb_redis Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284028"></a>cachedb_redis Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Vladut-Stefan</span> <span class="surname">Paiu</span></h3><div class="affiliation"><span class="orgname">OpenSIPS Solutions<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Vladut-Stefan</span> <span class="surname">Paiu</span></h3></div></div></div><div><p class="copyright">Copyright © 2011 <a class="ulink" href="http://www.opensips-solutions.com/" target="_top">www.opensips-solutions.com</a></p></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id284070">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id284083">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id248006">1.2. Advantages</a></span></dt><dt><span class="section"><a href="#id249585">1.3. Limitations</a></span></dt><dt><span class="section"><a href="#id249608">1.4. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id249614">1.4.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id249622">1.4.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id248880">1.5. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id248886">1.5.1. <code class="varname">cachedb_url</code> (string)</a></span></dt><dt><span class="section"><a href="#id248934">1.5.2. Exported Functions</a></span></dt><dt><span class="section"><a href="#id248944">1.5.3. Raw Query Syntax</a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248899">Set <code class="varname">cachedb_url</code> parameter</a></dt><dt>1.2. <a href="#id248920">Use Redis servers </a></dt><dt>1.3. <a href="#id293409">Redis Raw Query Examples</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id284070"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id284083"></a>1.1. Overview</h2></div></div></div><p>
		This module is an implementation of a cache system designed to work with a 
		Redis server. It uses hiredis client library to connect to either a single Redis
		server instance, or to a Redis Server inside a Redis Cluster.
		It uses the Key-Value interface exported from the core.
	</p><p>
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248006"></a>1.2. Advantages</h2></div></div></div><p>
		</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>memory costs are no longer on the server
				</em></span>
			</p></li><li><p>
				<span class="emphasis"><em>many servers can be used inside a cluster, so the memory
				is virtually unlimited</em></span>
			</p></li><li><p>
				<span class="emphasis"><em>the cache is 100% persistent. A restart
					of OpenSIPS server will not affect the DB. The Redis DB is also
				persistent so it can also be restarted without loss of information.</em></span>
			</p></li><li><p>
				<span class="emphasis"><em>redis is an open-source project so
				it can be used to exchange data
				 with various other applicationsr</em></span>
			</p></li><li><p>
				<span class="emphasis"><em>By creating a Redis Cluster, multiple OpenSIPS
				instances can easily share key-value information</em></span>
			</p></li></ul></div><p>
	</p><p>
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249585"></a>1.3. Limitations</h2></div></div></div><p>
			</p><div class="itemizedlist"><ul type="disc"><li><p>
			<span class="emphasis"><em>
		keys (in key:value pairs) may not contain spaces or control characters
		</em></span>
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249608"></a>1.4. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249614"></a>1.4.1. OpenSIPS Modules</h3></div></div></div><p>
		None.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249622"></a>1.4.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before running
		OpenSIPS with this module loaded:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>hiredis:</em></span>
			</p><p>
				On the latest Debian based distributions, hiredis can be installed
				by running 'apt-get install libhiredis-dev'

				Alternatively, if hiredis is not available on your OS repos,
				hiredis can be downloaded from: https://github.com/antirez/hiredis .
				Download the archive, extract sources, run make,sudo make install.
			</p></li></ul></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248880"></a>1.5. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248886"></a>1.5.1. <code class="varname">cachedb_url</code> (string)</h3></div></div></div><p>
			The urls of the server groups that OpenSIPS will connect to in order
			to use the from script cache_store,cache_fetch, etc operations.
			It can be set more than one time.
			The prefix part of the URL will be the identifier that will be used
			from the script.
		</p><div class="example"><a name="id248899"></a><p class="title"><b>Example 1.1. Set <code class="varname">cachedb_url</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("cachedb_redis", "cachedb_url","redis:group1://localhost:6379/");
modparam("cachedb_redis", "cachedb_url","redis:cluster1://random_url:8888/");
...
	</pre></div></div><br class="example-break"><div class="example"><a name="id248920"></a><p class="title"><b>Example 1.2. Use Redis servers </b></p><div class="example-contents"><pre class="programlisting">
...
cache_store("redis:group1","key","$ru value");
cache_fetch("redis:cluster1","key",$avp(10));
cache_remove("redis:cluster1","key");
...
	</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248934"></a>1.5.2. Exported Functions</h3></div></div></div><p>The module does not export functions to be used
		in configuration script.</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248944"></a>1.5.3. Raw Query Syntax</h3></div></div></div><p>
			The cachedb_redis module allows to run RAW queries, thus taking full advantage of the capabilities of the back-end.

			The query syntax is the typical REDIS one.
		</p><p>
			Here are a couple examples of running some Redis queries :
			</p><div class="example"><a name="id293409"></a><p class="title"><b>Example 1.3. Redis Raw Query Examples</b></p><div class="example-contents"><pre class="programlisting">
...
	$var(my_hash) = "my_hash_name";
	$var(my_key) = "my_key_name";
	$var(my_value) = "my_key_value";
	cache_raw_query("redis","HSET $var(my_hash) $var(my_key) $var(my_value)"); 
	cache_raw_query("redis","HGET $var(my_hash) $var(my_key)","$avp(result)");
	xlog("We have fetched $avp(result) \n"); 
...
	$var(my_hash) = "my_hash_name";
	$var(my_key1) = "my_key1_name";
	$var(my_key2) = "my_key2_name";
	$var(my_value1) = "my_key1_value";
	$var(my_value2) = "my_key2_value";
	cache_raw_query("redis","HSET $var(my_hash) $var(my_key1) $var(my_value1)"); 
	cache_raw_query("redis","HSET $var(my_hash) $var(my_key2) $var(my_value2)"); 
	cache_raw_query("redis","HGETALL $var(my_hash)","$avp(result)");

	$var(it) = 0;
	while ($(avp(result_final)[$var(it)]) != NULL) {
		xlog("Multiple key reply: - we have fetched $(avp(result_final)[$var(it)]) \n"); 
		$var(it) = $var(it) + 1;
	}
...
			</pre></div></div><p><br class="example-break">
		</p></div></div></div></div></body></html>
