<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>mi_xmlrpc Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284029"></a>mi_xmlrpc Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Lavinia-Andreea</span> <span class="surname">Andrei</span></h3></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Lavinia-Andreea</span> <span class="surname">Andrei</span></h3></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Juha</span> <span class="surname">Heinanen</span></h3></div></div></div><div><p class="copyright">Copyright © 2006 Voice Sistem SRL</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 8740 $</td><td align="left">$Date$</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id265403">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id258196">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id249368">1.2. To-do</a></span></dt><dt><span class="section"><a href="#id249059">1.3. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id249065">1.3.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id248014">1.3.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id249611">1.4. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id249617">1.4.1. <code class="varname">port</code>(integer)</a></span></dt><dt><span class="section"><a href="#id249652">1.4.2. <code class="varname">log_file</code>(string)</a></span></dt><dt><span class="section"><a href="#id249688">1.4.3. <code class="varname">reply_option</code> (integer)</a></span></dt><dt><span class="section"><a href="#id293417">1.4.4. <code class="varname">buffer_size</code> (integer)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293453">1.5. Exported Functions</a></span></dt><dt><span class="section"><a href="#id293462">1.6. Example</a></span></dt></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id249635">Set <code class="varname">port</code> parameter</a></dt><dt>1.2. <a href="#id249671">Set <code class="varname">log_file</code> parameter</a></dt><dt>1.3. <a href="#id293402">Set <code class="varname">reply_option</code> parameter</a></dt><dt>1.4. <a href="#id293436">Set <code class="varname">reply_option</code> parameter</a></dt><dt>1.5. <a href="#id293474">XMLRPC request</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id265403"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id258196"></a>1.1. Overview</h2></div></div></div><p>
		This module implements a xmlrpc server that handles xmlrpc requests and
		generates xmlrpc responses. When a xmlrpc message is received a default 
		method is executed.
	</p><p>
		At first, it looks up the MI command. If found it parses the called 
		procedure's parameters into a MI tree and the command is executed. A 
		MI reply tree is returned that is formatted back in xmlrpc. The 
		response is built in two ways - like a string that contains the MI 
		tree nodes information (name, values and attributes) or like an array 
		whose elements are consisted of each MI tree node stored information.
	</p><p>
		Implementation of mi_xmlrpc module's xmlrpc server is based on Abyss
		XML-RPC server.  Current version of Abyss server
		"normalizes" CRLF sequence in received XML-RPC strings
		to LF character, which makes it impossible to pass CRLF
		sequence from xmlrpc client application to OpenSIPS modules,
		such as mi_fifo and pua_mi, that accept requests via MI
		transport.  To overcome this limitation mi_xmlrpc module
		implements a hack that coverts each LFLF sequence in
	        received XML-RPC strings to CRLF sequence.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249368"></a>1.2. To-do</h2></div></div></div><p>
		Features to be added in the future:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
			possibility to select the listening IP address
			</p></li><li><p>
			multiple ports per IP address
			</p></li></ul></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249059"></a>1.3. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249065"></a>1.3.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>No dependencies on other OpenSIPS modules</em></span>.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248014"></a>1.3.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before 
		running OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>libxml</em></span>.
			</p></li><li><p>
				<span class="emphasis"><em>libxmlrpc-c3</em></span> version 0.9.10 - 0.9.42. (using other versions may be dangerous and lead to opensips blocking)
			</p></li><li><p>
				<span class="emphasis"><em>libxmlrpc-c3-dev</em></span> version 0.9.10 - 0.9.42.
			</p></li></ul></div><p>
		</p><p>
		If libxmlrpc-c3[-dev] package is not available on your system, you may
		check if packages for your OS are not available on the 
		&#8220;<span class="quote">xmlrpc-c</span>&#8221;project 
		(<a class="ulink" href="http://xmlrpc-c.sourceforge.net/" target="_top">
		http://xmlrpc-c.sourceforge.net/</a>). Otherwise you need
		to install the library and devel headers from the sources. In both
		cases, keep in mind to use the 0.9.10 version!!.
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249611"></a>1.4. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249617"></a>1.4.1. <code class="varname">port</code>(integer)</h3></div></div></div><p>
		The port number used by the XMLRPX server to listen for incoming 
		requests.
		</p><p>
		<span class="emphasis"><em>The default value is 8080.</em></span>
		Ports lower than 1024 are not accepted.
		</p><div class="example"><a name="id249635"></a><p class="title"><b>Example 1.1. Set <code class="varname">port</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("mi_xmlrpc", "port", 8000)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249652"></a>1.4.2. <code class="varname">log_file</code>(string)</h3></div></div></div><p>
		A log file to be used by the internal Abyss html server used by the 
		XMLRPX library.
		</p><p>
		<span class="emphasis"><em>The default values NONE (no logging).</em></span>
		</p><div class="example"><a name="id249671"></a><p class="title"><b>Example 1.2. Set <code class="varname">log_file</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("mi_xmlrpc", "log_file", "/var/log/abyss.log")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249688"></a>1.4.3. <code class="varname">reply_option</code> (integer)</h3></div></div></div><p>
		Given the xmlrpc response specifications that a methodResponse can 
		contain a single params section with a single param section, there is 
		the possibility to choose between a string built response or an 
		array built one.
		</p><p>
		For a 0 value, a single string parameter will be replied (merging the 
		whole response). For non-0 value, each line from the response will be 
		encoded as an element into an array of strings.
		</p><p>
		<span class="emphasis"><em>The default option is a string built response (0).</em></span>
		</p><div class="example"><a name="id293402"></a><p class="title"><b>Example 1.3. Set <code class="varname">reply_option</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("mi_xmlrpc", "reply_option", 0)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293417"></a>1.4.4. <code class="varname">buffer_size</code> (integer)</h3></div></div></div><p>
		It specifies the maximum length of the buffer used to write in the MI 
		tree node information in order to build the xmlrpc response.
		</p><p>
		<span class="emphasis"><em> The default value is 8192.</em></span>
		</p><div class="example"><a name="id293436"></a><p class="title"><b>Example 1.4. Set <code class="varname">reply_option</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("mi_xmlrpc", "buffer_size", 8192)
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293453"></a>1.5. Exported Functions</h2></div></div></div><p>
		No function exported to be used from configuration file.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293462"></a>1.6. Example</h2></div></div></div><p>
		This is an example showing the xmlrpc format for the 
		&#8220;<span class="quote">get_statistics dialog: tm:</span>&#8221; MI commad:
		response.
		</p><div class="example"><a name="id293474"></a><p class="title"><b>Example 1.5. XMLRPC request</b></p><div class="example-contents"><pre class="programlisting">


POST /RPC2 HTTP/1.0
Host: 127.0.0.1
Connection: close
User-Agent: OpenSIPg XML_RPC Client
Content-Type: text/xml
Content-Length: 1000

&lt;?xml version="1.0" ?&gt;
&lt;methodCall&gt;
   &lt;methodName&gt;get_statistics&lt;/methodName&gt;
   &lt;params&gt;
       &lt;param&gt;
           &lt;value&gt;&lt;string&gt;dialog:&lt;/string&gt;&lt;/value&gt;
       &lt;/param&gt;
       &lt;param&gt;
           &lt;value&gt;&lt;string&gt;tm:&lt;/string&gt;&lt;/value&gt;
       &lt;/param&gt;
  &lt;/params&gt;
&lt;/methodCall&gt;


</pre></div></div><br class="example-break"></div></div></div></body></html>
